Leitor = {}
Leitor.__index = Leitor

function Leitor.new()
	local leitor = {}
	setmetatable(leitor,Leitor)

	return leitor
end

function Leitor:cadastroDeEdicao(file, revista, edAtual)
	-- body
	local nomeTema = file:read()
	local tema
	for i,t in pairs( revista:getTemas() ) do
		if t:getNome() == nomeTema then
			tema = t;
			break
		end
	end
	if (tema == nil) then
		tema = Tema.new(nomeTema)
	end
	local editorChefe = file:read()
	--local volume = file:read("*n")
	--local numEdicao = file:read("*n")
	local volume = file:read()
	local numEdicao = file:read()
	local data = file:read()
	
	for i,rev in pairs( revista:getRevisores() ) do
		if editorChefe == rev:getNome() then
			edAtual = Edicao.new(tema, rev, volume, numEdicao,data)
			break
		end
	end
	--edAtual:setDataPubl(data)
	return edAtual
end

function Leitor:cadastroDeTemas(file, revista)
	for linha in file:lines() do
		local codTema, nomeTema, aux
		codTema, nomeTema, aux = string.match(linha,'%s*(%d+)%s*;%s*(.-)%s*;(.-)$')
		local tema = Tema.new(nomeTema)
		while aux ~= "" do
			if aux == nil then
				break
			end
			local codRevisor 
			codRevisor, aux = string.match(aux, '%s*(%d+)%s*,*(.-)$')
			local rev = revista:getRevisores()
			Capacitacao.new(tema,rev[tonumber(codRevisor)])
		end
		revista:addTema(tonumber(codTema), tema);
	end
end

function Leitor:cadastroDePessoas(file, revista)
	for linha in file:lines() do
		local codPessoa, nomePessoa, email, senha, instituicao, endereco, tipo
		codPessoa, nomePessoa, email, senha, instituicao, endereco, tipo = string.match(linha,'%s*(%d+)%s*;%s*(.-)%s*;%s*(.-)%s*;%s*(.-)%s*;%s*(.-)%s*;%s*(.-)%s*;%s*(%a)%s*')
		if tipo == 'A' then
			local autor = Autor.new(nomePessoa, email, Instituicao.new(instituicao))
			autor:setEndereco(endereco); 
			autor:setSenha(senha);
			revista:addAutor(tonumber(codPessoa),autor);
		elseif tipo == 'R' then
			local revisor = Revisor.new(nomePessoa, email, Instituicao.new(instituicao))
			revisor:setEndereco(endereco); 
			revisor:setSenha(senha);
			revista:addRevisor(tonumber(codPessoa),revisor);
		end
	end
end

function Leitor:cadastroDeArtigos(file, revista, edAtual)
	for linha in file:lines() do
		local codArtigo, nomeArtigo, aux
		codArtigo, nomeArtigo, aux = string.match(linha,'%s*(%d+)%s*;%s*(.-)%s*;(.-)$')
		codArtigo = tonumber(codArtigo)
		local contato = {}
		while aux ~= "" do
			if aux == nil then
				break
			end
			local codAutor 
			codAutor, aux = string.match(aux, '%s*(%d+)%s*,*;*(.-)$')
			codAutor = tonumber(codAutor)
			if (aux ~= "" and aux ~= nil) then
				--[[
				Se ainda há códigos de autores para serem lidos,
				o autor lido não é contato.
				]]--
				contato[codAutor] = false
			elseif contato[codAutor] == nil then
				--[[
				Caso o artigo possua apenas um autor, 
				ele é colocado como contato no mapa.
				]]--
				contato[codAutor] = true
			else
				--[[
				Seta um dos autores já existentes no mapa de contato
				como autor contato.
				]]--
				contato[codAutor] = true
			end
		end
		local artigo = Artigo.new(nomeArtigo)
		revista:addArtigo(codArtigo, artigo)
		edAtual:addArtigo(codArtigo, artigo)
		for codAutor, v in pairs( contato ) do
			local autores = revista:getAutores()
			Autoria.new(artigo,autores[codAutor],contato[codAutor])
		end
	end
end

function Leitor:cadastroDeRevisoes(file, revista, edAtual)
	for linha in file:lines() do
		local codArtigo, nomeArtigo, aux
		codArtigo, aux = string.match(linha,'%s*(%d+)%s*;(.-)$')
		codArtigo = tonumber(codArtigo)
		local listaArtigos = edAtual:getArtigos()
		local artigo = listaArtigos[codArtigo]
		
		local codRevisor, notaOriginalidade, notaConteudo, notaApresentacao
		codRevisor, aux = string.match(aux,'%s*(%d+)%s*;(.-)$')
		codRevisor = tonumber(codRevisor)
		
		notaOriginalidade, aux =  string.match(aux,'%s*(.-)%s*;(.-)$')
		notaOriginalidade = string.gsub(notaOriginalidade, ",", ".")
		notaOriginalidade = tonumber(notaOriginalidade)
		
		notaConteudo, aux =  string.match(aux,'%s*(.-)%s*;(.-)$')
		notaConteudo = string.gsub(notaConteudo, ",", ".")
		notaConteudo = tonumber(notaConteudo)
		
		notaApresentacao = aux--, aux =  string.match(aux,'%s*(.-)%s*;(.-)$')
		notaApresentacao = string.gsub(notaApresentacao, ",", ".")
		notaApresentacao = tonumber(notaApresentacao)
		
		local listaRevisores = revista:getRevisores()
		local revisor = listaRevisores[codRevisor]
		
		Revisao.new(artigo,revisor,notaOriginalidade,notaConteudo,notaApresentacao);
	end
end
