local Set = require("set")
require("Colaborador")

Revisor = Colaborador.new()
Revisor.__index = Revisor

function Revisor.new(nome,email,instituicao)
	local revisor = Colaborador.new(nome,email,instituicao)

	setmetatable(revisor,Revisor)

	revisor.revisoes = Set.new()
	revisor.capacitacoes = Set.new()
	revisor.edicoesChefiadas = Set.new()

	return revisor
end

function Revisor:getMediaRevisor(edAtual)
	local soma = 0
	local contador = 0
	for k,v in pairs(edAtual:getArtigos()) do
		for m,n in pairs(v:getRevisoes()) do
			if(self.revisoes:contains(n)) then
				soma = soma + n:getMediaNota()
				contador = contador + 1
			end
		end
	end
	return soma/contador
end

--[[
Revisor.__lt = function (lhs, rhs)

	if lhs:getNome() < rhs:getNome() then
		return -1
	elseif lhs:getNome() > rhs:getNome() then
		return 1
	else
		return 0
	end

	return lhs:getNome() < rhs:getNome()
end
--]]

function Revisor:getRevisoes()
	return self.revisoes
end

function Revisor:getCapacitacoes()
	return self.capacitacoes
end

function Revisor:addCapacitacao(c)
	self.capacitacoes:insert(c)
end

function Revisor:addRevisao(r)
	self.revisoes:insert(r)
end

function Revisor:getEdicoesChefiadas()
	return self.edicoesChefiadas
end

function Revisor:addEdicaoChefiada(e)
	self.edicoesChefiadas:insert(e)
end
